jQuery(document).ready(function ($) {

    var userCircles = BuddyCircles.circles;
    var userID = '';
    var $popover = '';
    var $contentHTML = '';
    var doUpdateLabelOnChange = typeof BuddyCircles.updateLabelOnChange ==="undefined" ? 1: Number.parseInt(BuddyCircles.updateLabelOnChange);

    var circleItemTemplate = _.template('<li class="<%= slectedClass %>"><label><input type="checkbox" <%= checked %> name="bcircles[]" id="bcircles-<%= id %>" value="<%= id %>"><%= label %></label></li>');

   // setEqualHeight( $('.bcircles-circle-entries li') );
    //Show the Circles Popup
    $(document).on('click', 'a.bcircles-add-circle', function () {

        var $el = $(this);

        $el.webuiPopover('destroy');
        userID = $el.data('user-id');

        var selectedCircles = "" + $el.data('engaged-circles');
        selectedCircles = selectedCircles.split(',');

        var $div = $('#bcircles-add-user');
        var $ul = $div.find('ul.bcircles-circle-list');
        $ul.empty();

        $div.find('div.bcircles-message').empty();

        for (var i = 0; i < userCircles.length; i++) {
            var idStr = userCircles[i].id.toString();
            var isChecked = $.inArray(idStr, selectedCircles) !== -1 ? true : false;
            var checked = isChecked ? "checked='checked'" : '';
            var selectedClass = isChecked? 'bcircle-list-entry bcircle-selected ': 'bcircle-list-entry bcircle-not-selected';
            $ul.append(circleItemTemplate({id: idStr, label: userCircles[i].label, checked: checked, slectedClass: selectedClass}));
        }

        $el.webuiPopover({title: BuddyCircles.circlesModalTitle, content: $div.html(), animation: 'pop'});

        $popover = getPopover($el);

        $el.webuiPopover('show');

        return false;
    });

    // Add new circle(from modal box)
    $(document).on('click', '#bcircles-add-circle-modal-btn', function () {
        var $el = $(this);
        var data = $el.parent('form').serialize();
        data += '&action=circle_modal_add_circle';

        $popover = getPopupElement($el);
        var $feedback = $popover.find('div.bcircles-message');
        $feedback.empty();
        $.post(ajaxurl, data, function (response) {

            if (response.success) {
                $('.bcircles-new-circle-name').val('');
                $popover.find('div.bcircles-message').empty().addClass('success').html("<p>" + response.data.message + "</p>");
                userCircles.push(response.data.circle);
                $popover.find('ul.bcircles-circle-list').append(response.data.html);

            } else{
                $feedback.addClass('error').html("<p>" + response.data.message + "</p>");
            }
        }, 'json');

        return false;
    });


    // Add new circle(from
    $(document).on('click', '#bcircles-add-circle-btn', function () {
        var $el = $(this);
        var data = $el.parent('form').serialize();
        data += '&action=circle_add_circle';

        var $feedback = $el.parents('div.bcircles-add-circle-section').find('div.bcircles-message');

        $feedback.empty();
        $.post(ajaxurl, data, function (response) {

            if (response.success) {
                $('.bcircles-new-circle-name').val('');
                $('ul.bcircles-circle-list').prepend(response.data.entry);
            } else {
                $feedback.addClass('error').html("<p>" + response.data.message + "</p>");
            }
        }, 'json');

        return false;
    });
    //Circle delete
    $(document).on('click', 'a.bcircles-circle-delete', function () {

        var $this = $(this);
        var circleID = $this.data('circle-id');

        var action = confirm(BuddyCircles.confirmMessage);

        if (action == false) {
            return false;
        }

        $.post(ajaxurl, {
            action: 'bcircles_delete_circle',
            circle_id: circleID,
            _wpnonce: BuddyCircles.nonce,
        }, function (response) {
            if (response.success) {
                window.location = response.data.url;
            } else {
                $this.parent().after("<div class='bcircles-message error'><p>" + response.data.message + "</p></div>");
            }
        }, 'json');

        return false;
    });

    //Edit Circle
    $(document).on('click', 'a.bcircles-circle-edit', function () {

        var $this = $(this);

        var $parentLI = $this.parents('li.bcircles-circle-item');
        $parentLI.find('.bcircles-circle-content').hide();
        $parentLI.find('.bcircles-circle-actions-links').hide();

        $parentLI.find('.bcircles-message').empty();//.html();
        $parentLI.find('.bcircles-circle-edit-section').show();//.html();

        return false;
    });

    // Add new circle
    $(document).on('click', '.bcircles-circle-update-btn', function () {

        var $this = $(this);
        var $parentLI = $this.parents('li');
        var data = $parentLI.find('form').serialize();
        data += '&action=circle_update_circle';

        $.post(ajaxurl, data, function (response) {
            if (response.success) {
                $parentLI.replaceWith(response.data.html);
            } else {
                $parentLI.find('.bcircles-message').addClass('error').html("<p>" + response.data.message + "</p>" );
                //$parentLI.replaceWith('bcircles-circle-edit-form')
            }
        }, 'json');

        return false;
    });

    // on cancel update circle action
    $(document).on('click', '.bcircles-update-cancel-btn', function () {

        var $this = $(this);
        var $parentLI = $this.parents('li');

        $parentLI.find('.bcircles-circle-edit-section').hide();//.html();
        $parentLI.find('.bcircles-circle-content').show();

        $parentLI.find('.bcircles-circle-actions-links').show();

        return false;
    });

    // Do not let the click action propagate. This is called magic.
    $(document).on('click', '.bcircles-privacy-dropdown', function (evt) {
        return false;
    });

    //add /remove to existing circles
    $(document).on('click', 'ul.bcircles-circle-list input[type="checkbox"]', function () {

        var $this = $(this),
            $li = $this.closest('li');
        var action = 'bcircles_delete_user';

        //we need to find that anchor
        var $popover = getPopupElement($this);
        var $el = getTriggerElement($popover);

        var count = $el.data('count');
        var singularLabel = $el.data('singular');
        var pluralLabel = $el.data('plural');

        if ($this.is(':checked')) {
            $li.removeClass('bcircle-not-selected').addClass('bcircle-selected');
            action = 'bcircles_add_user';
            count++;
        } else {
            $li.removeClass('bcircle-selected').addClass('bcircle-not-selected');
            count--;
        }

        var circleID = $this.val();
        var label;

        label = count > 1 ? count + " " + pluralLabel : count + " " + singularLabel;
        if (count <= 0) {
            label = BuddyCircles.addToCircleLabel;
        }
        $el.data('count', count);

        if (doUpdateLabelOnChange) {
            $el.text(label);
        }

        $.post(ajaxurl, {
            action: action,
            user_id: userID,
            circle_id: circleID,
            _wpnonce: BuddyCircles.nonce,
        }, function (response) {
            if (response.success) {
                $popover.find('div.bcircles-message').empty().addClass('success').html("<p>" + response.data.message + "</p>");
            } else {
                $popover.find('div.bcircles-message').empty().addClass('error').html("<p>" + response.data.message + "</p>");
            }
        }, 'json');

        return true;
    });

    // disable ajax pagination for circle members on single circle page.
    $( '.bcircles-members-list .pagination').addClass('no-ajax');

    function getTriggerElement($popover) {
        var target_id = $popover.attr('id');
        var $el = $('a[data-target="' + target_id + '"]');
        return $el;
    }

    function getPopupElement($el) {
        var $popover = $($el.parents('.webui-popover').get(0));
        return $popover;
    }

    function getPopover($el) {
        var pluginName = 'webuiPopover';
        return $($el).data('plugin_' + pluginName);
    }


    function setEqualHeight( $collection ) {
        var height = 0;

        $collection.each( function () {
            if( $(this).height() > height ) {
                height = $(this).height();
            }
        });

        $collection.css( {'height': height +'px' } );
    }
});