<?php
/**
 * Core functions file
 *
 * @package BuddyCircles
 * @subpackage BuddyPress
 */

namespace PressThemes\BuddyCircles\BuddyPress;

// Exit if file accessed directly.
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * Class Circle_Screens
 */
class Circle_Screens {

	/**
	 * Single
	 *
	 * @var bool
	 */
	private $single = false;

	/**
	 * Exists
	 *
	 * @var bool
	 */
	private $exists = false;

	/**
	 * Circles
	 */
	public function circles() {

		$circle_id = bp_action_variable( 0 );
		$do_404    = false;

		if ( ! $circle_id ) {
			add_action( 'bp_template_content', array( $this, 'circles_list' ) );
		} elseif ( ! bcircles_user_can_view_circle( bp_loggedin_user_id(), $circle_id ) ) {
			$do_404 = true;
		} else {
			add_action( 'bp_template_content', array( $this, 'members_list' ) );
		}

		if ( ! $do_404 ) {
			bp_core_load_template( array( 'members/single/plugins' ) );
		} else {
			bp_do_404();
		}
	}

	/**
	 * Circle list
	 */
	public function circles_list() {
		wp_enqueue_style( 'buddycircles' );
		require bcircles_locate_template( array( 'circles.php' ) );
	}

	/**
	 * Render member list
	 */
	public function members_list() {

		if ( ! bcircles_user_can_view_circle( bp_loggedin_user_id(), bp_action_variable( 0 ) ) ) {
			return '';
		}

		bcircles_locate_template( array( 'single.php' ), true );
	}

	/**
	 * Activity circles
	 */
	public function activity_circles() {
		bp_core_load_template( 'members/single/home' );
	}
 }